"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const react_native_1 = require("react-native");
const { UIManager } = react_native_1.NativeModules;
const useStateWithLayoutAnimation = (initialValue, setLayoutAnimationEnabledExperimental = true) => {
    react_1.useEffect(() => {
        if (setLayoutAnimationEnabledExperimental) {
            UIManager.setLayoutAnimationEnabledExperimental &&
                UIManager.setLayoutAnimationEnabledExperimental(true);
        }
    }, [setLayoutAnimationEnabledExperimental]);
    const [state, setState] = react_1.useState(initialValue);
    const partialSetState = react_1.useCallback((animationFn) => (nextState, onAnimationDidEnd) => {
        animationFn(onAnimationDidEnd);
        setState(nextState);
    }, []);
    const stateSetters = react_1.useRef({
        spring: partialSetState(react_native_1.LayoutAnimation.spring),
        linear: partialSetState(react_native_1.LayoutAnimation.linear),
        easeInEaseOut: partialSetState(react_native_1.LayoutAnimation.linear),
        noAnimation: setState,
    }).current;
    return [state, stateSetters];
};
exports.default = useStateWithLayoutAnimation;
